/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-velodyne-msgs-1.1.2-1quantal-20150326-2229/msg/VelodyneScan.msg
 *
 */


#ifndef VELODYNE_MSGS_MESSAGE_VELODYNESCAN_H
#define VELODYNE_MSGS_MESSAGE_VELODYNESCAN_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>
#include <velodyne_msgs/VelodynePacket.h>

namespace velodyne_msgs
{
template <class ContainerAllocator>
struct VelodyneScan_
{
  typedef VelodyneScan_<ContainerAllocator> Type;

  VelodyneScan_()
    : header()
    , packets()  {
    }
  VelodyneScan_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , packets(_alloc)  {
    }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef std::vector< ::velodyne_msgs::VelodynePacket_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::velodyne_msgs::VelodynePacket_<ContainerAllocator> >::other >  _packets_type;
  _packets_type packets;




  typedef boost::shared_ptr< ::velodyne_msgs::VelodyneScan_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::velodyne_msgs::VelodyneScan_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct VelodyneScan_

typedef ::velodyne_msgs::VelodyneScan_<std::allocator<void> > VelodyneScan;

typedef boost::shared_ptr< ::velodyne_msgs::VelodyneScan > VelodyneScanPtr;
typedef boost::shared_ptr< ::velodyne_msgs::VelodyneScan const> VelodyneScanConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::velodyne_msgs::VelodyneScan_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::velodyne_msgs::VelodyneScan_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace velodyne_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': True}
// {'velodyne_msgs': ['/tmp/buildd/ros-hydro-velodyne-msgs-1.1.2-1quantal-20150326-2229/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::velodyne_msgs::VelodyneScan_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::velodyne_msgs::VelodyneScan_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::velodyne_msgs::VelodyneScan_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::velodyne_msgs::VelodyneScan_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::velodyne_msgs::VelodyneScan_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::velodyne_msgs::VelodyneScan_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::velodyne_msgs::VelodyneScan_<ContainerAllocator> >
{
  static const char* value()
  {
    return "50804fc9533a0e579e6322c04ae70566";
  }

  static const char* value(const ::velodyne_msgs::VelodyneScan_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x50804fc9533a0e57ULL;
  static const uint64_t static_value2 = 0x9e6322c04ae70566ULL;
};

template<class ContainerAllocator>
struct DataType< ::velodyne_msgs::VelodyneScan_<ContainerAllocator> >
{
  static const char* value()
  {
    return "velodyne_msgs/VelodyneScan";
  }

  static const char* value(const ::velodyne_msgs::VelodyneScan_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::velodyne_msgs::VelodyneScan_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# Velodyne LIDAR scan packets.\n\
\n\
Header           header         # standard ROS message header\n\
VelodynePacket[] packets        # vector of raw packets\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: velodyne_msgs/VelodynePacket\n\
# Raw Velodyne LIDAR packet.\n\
\n\
time stamp              # packet timestamp\n\
uint8[1206] data        # packet contents\n\
\n\
";
  }

  static const char* value(const ::velodyne_msgs::VelodyneScan_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::velodyne_msgs::VelodyneScan_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.packets);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct VelodyneScan_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::velodyne_msgs::VelodyneScan_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::velodyne_msgs::VelodyneScan_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "packets[]" << std::endl;
    for (size_t i = 0; i < v.packets.size(); ++i)
    {
      s << indent << "  packets[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::velodyne_msgs::VelodynePacket_<ContainerAllocator> >::stream(s, indent + "    ", v.packets[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // VELODYNE_MSGS_MESSAGE_VELODYNESCAN_H
